﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Syncfusion.Reporting.Web.ReportViewer;
using System.Web.Http.Cors;
using System.Web.Http.Controllers;

namespace ReportViewerDemo.Controllers
{
    public class DefaultCaseControllerConfigAttribute : Attribute, System.Web.Http.Controllers.IControllerConfiguration
    {
        void IControllerConfiguration.Initialize(HttpControllerSettings controllerSettings, HttpControllerDescriptor controllerDescriptor)
        {
            var formatter = controllerSettings.Formatters.OfType<System.Net.Http.Formatting.JsonMediaTypeFormatter>().Single();
            controllerSettings.Formatters.Remove(formatter);

            formatter = new System.Net.Http.Formatting.JsonMediaTypeFormatter
            {
                SerializerSettings = { ContractResolver = new Newtonsoft.Json.Serialization.DefaultContractResolver() }
            };

            controllerSettings.Formatters.Add(formatter);
        }
    }
}
[DefaultCaseControllerConfigAttribute]
[EnableCors(origins: "*", headers: "*", methods: "*")]
//[Route("api/[controller]/[action]")]
public class ReportViewerController : ApiController, IReportController
{
    protected string reportPath = System.Web.Hosting.HostingEnvironment.MapPath("~/Resources/");

    #region test rdl path
    [System.Web.Http.ActionName("Getpath")]
    [AcceptVerbs("GET")]
    public String Get()
    {
        var path = System.Web.Hosting.HostingEnvironment.MapPath("~/Resources/");
        //   var hostpath = System.Web.HttpContext.Current.Server.MapPath("~/Resources/");
        var rdlpath = path;
        return rdlpath;
    }
    #endregion

    [System.Web.Http.ActionName("GetResource")]
    [AcceptVerbs("GET")]
    public object GetResource(string key, string resourcetype, bool isPrint)
    {
        return ReportHelper.GetResource(key, resourcetype, isPrint);
        //throw new NotImplementedException();
    }

    public void OnInitReportOptions(ReportViewerOptions reportOption)
    {
        var path = System.Web.Hosting.HostingEnvironment.MapPath("~/Resources/");
        reportOption.ReportModel.ReportPath = path;
        throw new NotImplementedException();
    }

    public void OnReportLoaded(ReportViewerOptions reportOption)
    {
        throw new NotImplementedException();
    }

    public object PostReportAction(Dictionary<string, object> jsonResult)
    {
        return ReportHelper.ProcessReport(jsonResult, this);
        //throw new NotImplementedException();
    }
}

